# -*- coding: utf-8 -*-
"""

    ファイル名：   synthesizer.py

    処理内容：

        synthesizer メイン

"""
from __future__ import unicode_literals

print( 'import strftime' )
from time   import strftime
print( strftime('%H:%M:%S import sys') )
import sys
print( strftime('%H:%M:%S import os') )
import os

#-------------------------------------------------------------------------------
#   sys.path への処理
#-------------------------------------------------------------------------------
thisdir_ = os.path.dirname( os.path.abspath( __file__ ) )
libdir_ = thisdir_ + '/lib'
if os.path.exists( libdir_ ):
    sys.path.append( libdir_ )
else:
    updir_ = os.path.dirname( thisdir_ )
    libdir_ = updir_ + '/lib'
    if os.path.exists( libdir_ ):
        sys.path.append( libdir_ )

from CommandLineOptions import opts

if opts.version:
    from AppVersion             import get_app_version_string
    print( get_app_version_string() )
    sys.exit()

if opts.command:
    from CommandController import Controller
    cmd = Controller( opts )
    cmd.execute()
    sys.exit()

print( strftime('%H:%M:%S tkinter') )
if sys.version_info > (3,):
    import tkinter as Tk
    import tkinter.simpledialog
    import tkinter.scrolledtext
    import tkinter.ttk as ttk
    import tkinter.tix
else:
    import Tkinter as Tk
    import tkSimpleDialog
    import ScrolledText
    import ttk
    import Tix

print( strftime('%H:%M:%S screeninfo') )
import screeninfo

from SplashScreen   import SplashScreen
from TkUtils        import adjusted_geometry

root = Tk.Tk()

sp = SplashScreen(root)
# sp.config(bg="#3366ff")

m = Tk.Label(sp, text="Synthesizer GUI is Loading...\nPlease be patient.")
m.pack(side=Tk.TOP, expand=Tk.YES)
m.config( justify=Tk.CENTER, font=("calibri", 29))
bar = ttk.Progressbar(sp, orient='horizontal', length=400, mode='determinate')
bar.pack( pady=80 )
bar["value"]    = 3
bar["maximum"]  = 18

root.update()
geometry_ = adjusted_geometry( "600x400+200+200" )
# print( 'geometry_=', geometry_ )
root.geometry( geometry_ )
root.update()

def update_bar( root, bar ):
    bar["value"] += 1
    root.update()

# ----- pyinstaller help imports begin -----------------------------------------
print( strftime('%H:%M:%S symbol') )
import symbol
update_bar( root, bar )
print( strftime('%H:%M:%S packaging.version') )
import packaging.version
update_bar( root, bar )
print( strftime('%H:%M:%S packaging.specifiers') )
import packaging.specifiers
update_bar( root, bar )
print( strftime('%H:%M:%S numpy') )
import numpy
update_bar( root, bar )
#    mkl_intel_thread.dll
#    mkl_core.dll
#    libiomp5md.dll
#    mkl_avx2.dll
#    mkl_def.dll
print( strftime('%H:%M:%S pylab') )
import pylab
update_bar( root, bar )
print( strftime('%H:%M:%S pandas') )
import pandas
update_bar( root, bar )
print( strftime('%H:%M:%S fabio') )
import fabio
update_bar( root, bar )
print( strftime('%H:%M:%S lxml') )
import lxml
update_bar( root, bar )
# ----- pyinstaller help imports end   -----------------------------------------

print( strftime('%H:%M:%S matplotlib.backends.backend_tkagg') )
import matplotlib.backends.backend_tkagg
update_bar( root, bar )
print( strftime('%H:%M:%S mpl_toolkits.axes_grid1') )
import mpl_toolkits.axes_grid1
update_bar( root, bar )
print( strftime('%H:%M:%S mpl_toolkits.mplot3d') )
import mpl_toolkits.mplot3d
update_bar( root, bar )
print( strftime('%H:%M:%S ToolTip') )
from idlelib.ToolTip import ToolTip
update_bar( root, bar )
print( strftime('%H:%M:%S AppVersion') )
update_bar( root, bar )
from AppVersion             import get_app_version_string

root.withdraw()
root.wm_title( get_app_version_string() )

from GuiController import Controller
gui = Controller( root, opts )
root.mainloop()
